#include <avr/interrupt.h>
#include "buzzer.h"

void BuzzerInit(void) {
  // OC1A auf Ausgang
  DDRD = (1 << PD7 );  
  //
  // Timer 2 einstellen
  //  
  // Modus 14:
  //    Fast PWM, Top von ICR1
  //
  //    WGM13    WGM12   WGM11    WGM10
  //      1        1       1        0
  //
  //    Timer Vorteiler: 1
  //     CS12     CS11    CS10
  //       0        0       1
  //
  //  Steuerung des Ausgangsport: Set at BOTTOM, Clear at match
  //     COM1A1   COM1A0
  //       1        0
 
  TCCR2A = (1<<COM2A1) | (1<<WGM22) | (1<<WGM20);
  TCCR2B = (1<<CS21);
 
  //  den Endwert (TOP) für den Zähler setzen
  //  der Zähler zählt bis zu diesem Wert
 
  //ICR1 = 0xFF;
  disableBuzzer(); 
}
 
void enableBuzzer(void) {
  // der Compare Wert
  // Wenn der Zähler diesen Wert erreicht, wird mit
  // obiger Konfiguration der OC1A Ausgang abgeschaltet
  // Sobald der Zähler wieder bei 0 startet, wird der
  // Ausgang wieder auf 1 gesetzt
  //
  // Durch Verändern dieses Wertes, werden die unterschiedlichen
  // PWM Werte eingestellt.
  OCR2A = 0x80;
}

void disableBuzzer(void) {
  OCR2A = 0x00;
}
